// ---------------------------------------------------------------------------
// - t_vector.cpp                                                            -
// - standard object library - vector class tester                           -
// ---------------------------------------------------------------------------
// - This program is free software;  you can redistribute it  and/or  modify -
// - it provided that this copyright notice is kept intact.                  -
// -                                                                         -
// - This program  is  distributed in  the hope  that it will be useful, but -
// - without  any  warranty;  without  even   the   implied    warranty   of -
// - merchantability or fitness for a particular purpose.  In no event shall -
// - the copyright holder be liable for any  direct, indirect, incidental or -
// - special damages arising in any way out of the use of this software.     -
// ---------------------------------------------------------------------------
// - copyright (c) 1999-2000 amaury darsch                                   -
// ---------------------------------------------------------------------------

#include "Vector.hpp"
#include "String.hpp"

int main (int, char**) {
  using namespace aleph;

  // create a new vector
  Vector  vector;
  String* hello  = new String ("hello");
  String* world  = new String ("world");
  
  // insert out favorite message
  vector.append (hello);
  vector.append (world);

  // check vector size
  if (vector.length () != 2) return 1;

  // get first object
  Object* object = vector.get (0);
  String* string = dynamic_cast <String*> (object);

  // check for string
  if (string  == nilp)    return 1;
  if (*string != "hello") return 1;

  // query next string
  object = vector.get (1);
  string = dynamic_cast <String*> (object);

  // check for string
  if (string  == nilp)     return 1;
  if (*string != "world") return 1;

  // ok - everything is fine
  return 0;
}
